-- *********************************************************************************************************************
-- *                           (c) 2013 by White Elephant GmbH, Schaffhausen, Switzerland                              *
-- *                                               www.white-elephant.ch                                               *
-- *                                                                                                                   *
-- *    This program is free software; you can redistribute it and/or modify it under the terms of the GNU General     *
-- *    Public License as published by the Free Software Foundation; either version 2 of the License, or               *
-- *    (at your option) any later version.                                                                            *
-- *                                                                                                                   *
-- *    This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the     *
-- *    implied warranty of MERCHANTABILITY or FITNESS for A PARTICULAR PURPOSE. See the GNU General Public License    *
-- *    for more details.                                                                                              *
-- *                                                                                                                   *
-- *    You should have received a copy of the GNU General Public License along with this program; if not, write to    *
-- *    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.                *
-- *********************************************************************************************************************
-->Style: White_Elephant

with Message;
with Npp.Plugin;
with System;
with Win.Dll;

package body Hello_Dll is

  Wide_Nul : constant Wide_Character := Wide_Character'first;

  Promote_Toolbar : aliased Npp.Toolbar_Icons;


  procedure Load_Resources is
    Bitmap : aliased constant String := "PromoteBmp" & Ascii.Nul;
  begin
    Promote_Toolbar.Bmp := Win.Load_Bitmap (Win.Dll.Instance, Bitmap);
  end Load_Resources;


  Name : aliased constant Wide_String := "Ada Plugin" & Wide_Nul;

  function Get_Name return System.Address is
  begin
    return Name'address;
  end Get_Name;


  procedure About is
  begin
    Message.Write_Line ("N++ plugin demo written in Ada.");
  end About;


  procedure Promote is
  begin
    Message.Write_Line ("Hello World", Message.Magenta);
  end Promote;


  procedure Set_Info is
  begin
    Load_Resources;
    Npp.Plugin.Add_Function ("Promote", Promote'access, Promote_Toolbar);
    Npp.Plugin.Add_Function ("About", About'access);
  end Set_Info;

begin
  Npp.Plugin.Install (Set_Info => Set_Info'access);
end Hello_Dll;
